<?php
/**
 * Created by PhpStorm.
 * User: qf
 * Date: 2022-03-04
 * Time: 10:39
 */

if (!defined('IN_DISCUZ')) {
    exit('Access Denied');
}
require_once libfile('function/common', 'plugin/qffloor');

$setconfig = $_G['cache']['plugin'][CURMODULE];
$setconfig['message_minsize'] = 3;
$setconfig['message_maxsize'] = 200;
$setconfig['get_credit'] = 1;
$setconfig['notice_author'] = 1;
$setconfig['thread_bump'] = 1;
$setconfig['today_posts'] = 1;
$setconfig['replace_pc'] = 2;

$ac = in_array($_GET['ac'], array('index', 'post', 'delete')) ? $_GET['ac'] : 'index';

require_once libfile('function/forum');

loadforum();
$thread = $_G['thread'];
if (!$thread || $thread['displayorder'] < 0) {
    showmessage('thread_nonexistence');
}
$post = C::t('forum_post')->fetch('tid:' . $_G['tid'], $_GET['pid']);
if (!$post['tid']) {
    showmessage(lang('plugin/' . CURMODULE, 'replyfloor_post_nonexistence'));
}
if ($post['tid'] != $_G['tid']) {
    showmessage(lang('plugin/' . CURMODULE, 'replyfloor_post_error'));
}

if ($ac == 'index') {
//    $_G['setting']['dateconvert'] = $setconfig['date_convert'];
    $msgid = intval($_GET['msgid']);
    if ($msgid) {
        $msginfo = C::t('#' . CURMODULE . '#qianfan_post_floor')->fetch_by_id($msgid);
        if (!$msginfo) {
            showmessage(lang('plugin/' . CURMODULE, 'message_nonexistence'));
        }
    } else {
        $page = max(1, $_G['page']);

        $setconfig['show_count'] = $setconfig['show_count'] > 0 ? $setconfig['show_count'] : 5;
        $perpage = $setconfig['page_count'] > 0 ? $setconfig['page_count'] : 10;

        $start = ($page - 1) * $perpage;
        $mpurl = 'plugin.php?id=' . CURMODULE . ':index&tid=' . $post['tid'] . '&pid=' . $post['pid'];
        $wherearr = array();
        $wherearr[] = DB::field('status', 1);
        $wherearr[] = DB::field('pid', $post['pid']);
        $pidArr = array();
        $pidArr[] = $post['pid'];

        $count = C::t('#' . CURMODULE . '#qianfan_post_floor')->fetch_count_by_where($wherearr);
        $orderby = 'order by created_at asc';
        $list = C::t('#' . CURMODULE . '#qianfan_post_floor')->fetch_all_by_where($wherearr, $orderby, $start, $perpage);

        foreach ($list as $key => $value) {
            $list[$key] = $value;
        }

        if (defined('IN_MOBILE')) {
            $multipage = multi($count, $perpage, $page, $mpurl, 0, 3, false, true);
        } else {
            $multipage = multi($count, $perpage, $page, $mpurl);
        }
    }
    include template(CURMODULE . ':message');

} elseif ($ac == 'post') {
    if (empty($_G['uid'])) {
        showmessage('to_login', '', array(), array('showmsg' => true));
    }
    cknewuser();
    require_once libfile('function/post');
    require_once libfile('function/forumlist');
    $allowpostreply = ($_G['forum']['allowreply'] != -1) && (($_G['forum_thread']['isgroup'] || (!$_G['forum_thread']['closed'] && !checkautoclose($_G['forum_thread']))) || $_G['forum']['ismoderator']) && ((!$_G['forum']['replyperm'] && $_G['group']['allowreply']) || ($_G['forum']['replyperm'] && forumperm($_G['forum']['replyperm'])) || $_G['forum']['allowreply']);
    if (!$allowpostreply) {
        showmessage(lang('plugin/' . CURMODULE, 'replyfloor_no_permission_to_post'));
    }


    $ruid = 0;
    $rusername = '';
    $_GET['msgid'] = intval($_GET['msgid']);
    if ($_GET['msgid']) {
        $remsg = C::t('#' . CURMODULE . '#qianfan_post_floor')->fetch_by_id($_GET['msgid']);
        writelog('zz_qf_floor_log', var_export($remsg, true));

        if ($remsg) {
            $ruid = $remsg['ruid'];
            $rusername = $remsg['rusername'];
        }
    }
    if (submitcheck('savesubmit')) {
        $message = isset($_GET['message']) ? censor($_GET['message']) : '';
        if (empty($message)) {
            showmessage(lang('plugin/' . CURMODULE, 'message_message_empty'));
        }
        //$message = messagecutstr($message, 200, '');
        if (strlen($message) < $setconfig['message_minsize']) {
            showmessage(lang('plugin/' . CURMODULE, 'message_message_tooshort'), '', array('message_minsize' => $setconfig['message_minsize']));
        }
        if (strlen($message) > $setconfig['message_maxsize']) {
            showmessage(lang('plugin/' . CURMODULE, 'message_message_toolong'), '', array('message_minsize' => $setconfig['message_maxsize']));
        }
        if (checkflood()) {
            showmessage('post_flood_ctrl', '', array('floodctrl' => $_G['setting']['floodctrl']));
        }

        // 审核判断
        list(, $modnewreplies) = threadmodstatus($message);
        $pinvisible = $modnewreplies ? -2 : ($thread['displayorder'] == -4 ? -3 : 0);
        if ($pinvisible == -2) {
            $status = 0;
        } elseif ($pinvisible == -3) {
            $status = 3;
        } else {
            $status = 1;
        }

        $parent_id = $_GET['msgid'];
        $data = [
            'tid' => $post['tid'],
            'fid' => $_G['fid'],
            'pid' => $post['pid'],
            'parent_id' => $parent_id,
            'platform' => 0,
            'message' => $message,
            'authorid' => $_G['uid'],
            'author' => $_G['username'],
            'useip' => $_G['clientip'],
            'status' => $status,
            'anonymous' => 0,
            'created_at' => $_G['timestamp'],
            'updated_at' => $_G['timestamp'],
        ];

        $msgid = C::t('#' . CURMODULE . '#qianfan_post_floor')->insert($data, true);
        if ($setconfig['get_credit']) {
            updatepostcredits('+', $_G['uid'], 'reply', $_G['fid']);
        }
        if ($setconfig['thread_bump']) {
            $expiration = $_G['timestamp'];
            C::t('forum_thread')->update($thread['tid'], array('lastpost' => $expiration), true);
            C::t('forum_forum')->update($_G['fid'], array('lastpost' => "$thread[tid]\t$thread[subject]\t$expiration\t$thread[lastposter]"));

            $_G['forum']['threadcaches'] && deletethreadcaches($thread['tid']);
        }
        if ($setconfig['notice_author'] == 1 || ($setconfig['notice_author'] == 2 && $_GET['notice_author'])) {
            $nauthorid = $ruid ? $ruid : $post['authorid'];
            if ($nauthorid && $nauthorid != $_G['uid']) {
                notification_add($nauthorid, 'post', 'qffloor:replyfloor_noticeauthor', array(
                    'tid' => $thread['tid'],
                    'subject' => $thread['subject'],
                    'fid' => $_G['fid'],
                    'pid' => $post['pid'],
                    'from_id' => $post['tid'],
                    'from_idtype' => 'post',
                ));
            }
        }

        if ($setconfig['today_posts']) {
            C::t('forum_forum')->update_forum_counter($_G['fid'], 0, 0, 1);
        }

        showmessage('', dreferer(), array('tid' => $post['tid'], 'pid' => $post['pid'], 'msgid' => $msgid));
    } else {
        include template(CURMODULE . ':post');
    }
} elseif ($ac == 'delete') {
    if (empty($_G['uid'])) {
        showmessage('to_login', '', array(), array('showmsg' => true, 'login' => 1));
    }
    $msgid = intval($_GET['msgid']);
    if ($msgid) {
        $msginfo = C::t('#' . CURMODULE . '#qianfan_post_floor')->fetch_by_id($msgid);
        if (!$msginfo) {
            showmessage(lang('plugin/' . CURMODULE, 'message_nonexistence'));
        }
    } else {
        showmessage(lang('plugin/' . CURMODULE, 'message_nonexistence'));
    }
    if (!($_G['forum']['ismoderator'] && $_G['group']['allowdelpost']) && !($setconfig['allow_delete'] && $_G['uid'] && $_G['uid'] == $_G['thread']['authorid']) && !($setconfig['self_delete'] && $_G['uid'] && $_G['uid'] == $msginfo['uid'])) {
        showmessage(lang('plugin/' . CURMODULE, 'replyfloor_no_permission'));
    }
    require_once libfile('function/misc');
    if (submitcheck('modsubmit')) {
        if ($setconfig['get_credit']) {
            require_once libfile('function/post');
            updatepostcredits('-', $msginfo['uid'], 'reply', $_G['fid']);
        }

        writelog('zz_qf_floor_log', var_export($msgid, true));

        C::t('#' . CURMODULE . '#qianfan_post_floor')->delete_by_id(array($msgid), $setconfig['enable_recycle']);
        $wherearr = array();
        $wherearr[] = DB::field('status', 1);
        $wherearr[] = DB::field('pid', $post['pid']);
        $count = C::t('#' . CURMODULE . '#qianfan_post_floor')->fetch_count_by_where($wherearr);
        showmessage('', dreferer(), array('tid' => $post['tid'], 'pid' => $post['pid'], 'count' => $count));
    } else {
        include template(CURMODULE . ':delete');
    }
}