<?php
/**
 * Created by PhpStorm.
 * User: sunbing
 * Date: 2022-02-25
 * Time: 14:33
 */

if (!defined('IN_DISCUZ')) {
    exit('Access Denied');
}
require_once libfile('function/common', 'plugin/qffloor');

class table_qianfan_post_floor extends discuz_table
{
    public function __construct()
    {
        $this->_table = 'qianfan_post_floor';
        $this->_pk = 'id';

        parent::__construct();
    }

    public function fetch_list_by_pids($pid, $order, $limit = 10)
    {
        $data = array();
        $listCount = array();
        $list = array();
        $all = array();
        $status = 1;
        $floors = DB::fetch_all('SELECT * FROM %t WHERE pid IN (%n) AND status=%d ' . $order . DB::limit(0, 2000), array($this->_table, $pid, $status));

        foreach ($floors as $floor) {
            $all[$floor['id']] = $floor;
        }
        foreach ($floors as $floor) {
            $listCount[$floor['pid']]++;
            if (count($list[$floor['pid']]) < $limit) {
                $parent = $floor['parent_id'] && isset($all[$floor['parent_id']]) ? $all[$floor['parent_id']] : array();
                $list[$floor['pid']][] = $this->handleFloor($floor, $parent, true);
            }
            $data[$floor['pid']]['count'] = $listCount[$floor['pid']];
            $data[$floor['pid']]['list'] = $list[$floor['pid']];
        }

        return $data;
    }

    public function fetch_all_by_where($wherearr = array(), $ordersql = '', $offset = 0, $limit = 100)
    {
        $wherearr = implode(' AND ', $wherearr);
        $floors = DB::fetch_all('
                SELECT *
			    FROM %t
			    WHERE %i ' . $ordersql . DB::limit($offset, $limit),
            array($this->_table, $wherearr)
        );

        $list = array();
        $parentFloorId = array();
        $all = array();
        foreach ($floors as $v) {
            if ($v['parent_id']) {
                $parentFloorId[] = $v['parent_id'];
            }
        }
        if ($parentFloorId) {
            $allParent = DB::fetch_all('SELECT * FROM %t WHERE id IN(%n)', array($this->_table, $parentFloorId), false, true);
            foreach ($allParent as $parent) {
                $all[$parent['id']] = $parent;
            }
        }

        foreach ($floors as $floor) {
            $parent = $floor['parent_id'] && isset($all[$floor['parent_id']]) ? $all[$floor['parent_id']] : array();
            $list[] = $this->handleFloor($floor, $parent, true);
        }
        return $list;
    }

    public function fetch_count_by_where($wherearr = array())
    {
        $wherearr = implode(' AND ', $wherearr);
        return DB::result_first('
                SELECT COUNT(*)
			    FROM %t
			    WHERE %i ',
            array($this->_table, $wherearr)
        );
    }

    public function fetch_by_id($id)
    {
        $list = array();
        $parentFloor = array();
        $floor = DB::fetch_first('SELECT * FROM %t WHERE id=%d', array($this->_table, $id));
        if ($floor) {
            if ($floor['parent_id']) {
                $parentFloor = DB::fetch_first('SELECT * FROM %t WHERE id=%d', array($this->_table, $floor['parent_id']));
            }
            $list = $this->handleFloor($floor, $parentFloor, true);
        }

        return $list;
    }

    public function fetch_by_ids($ids)
    {
        if (($ids = dintval((array)$ids, true))) {
            return DB::fetch_all('SELECT * FROM %t WHERE id IN(%n)', array($this->_table, $ids), false, true);
        }
        return array();
    }

    public function insert($data, $return_insert_id = false, $replace = false, $silent = false)
    {
        global $_G;
        $insertId = DB::insert($this->_table, $data, $return_insert_id, $replace, $silent);
        $floorStats = DB::fetch_first('SELECT * FROM %t WHERE tid=%d and pid=%d', array('qianfan_post_floor_stats', $data['tid'], $data['pid']));
        if (!$floorStats) {
            $stats = array(
                'tid' => $data['tid'],
                'pid' => $data['pid'],
                'total' => 1,
                'approve_num' => ($data['status'] == 1) ? 1 : 0,
                'created_at' => $_G['timestamp'],
                'updated_at' => $_G['timestamp'],
            );
            DB::insert('qianfan_post_floor_stats', $stats, false);
        } else {
            $sql = array();
            $sql[] = "`total`=`total`+'1'";
            if ($data['status'] == 1) {
                $sql[] = "`approve_num`=`approve_num`+'1'";
            }
            DB::query('UPDATE %t SET ' . implode(',', $sql) . ' WHERE tid=%d and pid=%d', array('qianfan_post_floor_stats', $data['tid'], $data['pid']));
        }
        return $insertId;
    }

    public function delete_by_id($ids, $recycle = 0)
    {
        if (($ids = dintval((array)$ids, true))) {
            if ($recycle) {
                DB::update($this->_table, array('status' => 2), DB::field('id', $ids, 'in'), true);
            } else {
                DB::query('DELETE FROM %t WHERE id IN(%n)', array($this->_table, $ids), false, true);
            }
        }
        return true;
    }


    private function handleFloor($floor, $parent = array(), $formatDate = false)
    {
        $list['id'] = $floor['id'];
        $list['tid'] = $floor['tid'];
        $list['pid'] = $floor['pid'];
        $list['uid'] = $floor['anonymous'] ? 0 : $floor['authorid'];
        $list['username'] = $floor['anonymous'] ? '匿名' : $floor['author'];
        $list['direct'] = $floor['anonymous'] ? 'javascript:void(0)' : 'home.php?mod=space&uid=' . $list['uid'];
        $list['anonymous'] = $floor['anonymous'];
        $list['ruid'] = 0;
        $list['rusername'] = '';
        $list['ranonymous'] = 0;
        if (isset($parent['author']) && isset($parent['author']) && isset($parent['anonymous'])) {
            $list['ranonymous'] = (int)$parent['anonymous'];
            $list['ruid'] = $parent['anonymous'] ? 0 : $parent['authorid'];
            $list['rusername'] = $parent['anonymous'] ? '匿名' : $parent['author'];
            $list['rdirect'] = $parent['anonymous'] ? 'javascript:void(0)' : 'home.php?mod=space&uid=' . $list['ruid'];
        }

        $list['avatar'] = discuz_uc_avatar($floor['authorid'], 'big', true);
        $list['status'] = $floor['status']; // todo
        $list['message'] = reply_discuzcode($floor['message']);
        $list['createtime'] = $formatDate ? dgmdate($floor['created_at'], 'u') : $floor['created_at'];

        return $list;
    }


}